searchNodes=[{"doc":"Resourceful is a library intended to provide a common interface for generic operations and representations for resources in an edge-facing API. These include: Filtering Introspection Pagination Representation Searching Sorting Input validation Type checking Its defaults are intended to be appropriate for web-based APIs. For instance, the filters are significantly simpler than SQL. The format for items such as sorting and pagination are also intended for easy adaptation to URL query strings. (The entire library is opinionated toward this use case.) Resources themselves are expected to be maps or structs.","ref":"Resourceful.html","title":"Resourceful","type":"module"},{"doc":"Provides a common interface for querying and retrieving collections. Deligated modules designed to interact directly with the underlying data or data sources must return alls of resources. For instance, when using Ecto , this module should return alls of structs or maps and not queries that have not been executed yet. Data Sources A data_source can be another from an Ecto schema, to a module that intteracts with a remote API, to a list as long as there is an underlying module to support the common interfaces. (For now, that's just Ecto.)","ref":"Resourceful.Collection.html","title":"Resourceful.Collection","type":"module"},{"doc":"Returns a list of resources that may be filtered and sorted depending on on options. Resources will always be paginated. Args: data_source : See module overview. opts : Keyword list of options Options: filter : See Resourceful.Collection.Filter.call/2 page : Pagination options. sort: See Resourceful.Collection.Sort.call/2 Additionally, see settings for the delegated module as it may take additional options.","ref":"Resourceful.Collection.html#all/2","title":"Resourceful.Collection.all/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#all_with_page_info/2","title":"Resourceful.Collection.all_with_page_info/2","type":"function"},{"doc":"Checks if data_source contains any resources. Args: data_source : See module overview. opts : Keyword list of options Options: See settings for the delegated module (e.g. Resourceful.Collection.Ecto ).","ref":"Resourceful.Collection.html#any?/2","title":"Resourceful.Collection.any?/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#default_page_size/0","title":"Resourceful.Collection.default_page_size/0","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#filter/3","title":"Resourceful.Collection.filter/3","type":"function"},{"doc":"Returns the total number of resources and pages based on page_size in a data_source . Args: data_source : See module overview. opts : Keyword list of options Options: See settings for the delegated module (e.g. Resourceful.Collection.Ecto ).","ref":"Resourceful.Collection.html#page_info/2","title":"Resourceful.Collection.page_info/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#page_info/3","title":"Resourceful.Collection.page_info/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#page_number_or_default/1","title":"Resourceful.Collection.page_number_or_default/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#page_size_or_default/1","title":"Resourceful.Collection.page_size_or_default/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#paginate/2","title":"Resourceful.Collection.paginate/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#paginate/4","title":"Resourceful.Collection.paginate/4","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#paginate_with_info/2","title":"Resourceful.Collection.paginate_with_info/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#query/2","title":"Resourceful.Collection.query/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#sort/3","title":"Resourceful.Collection.sort/3","type":"function"},{"doc":"Returns the total number of resources in a data_source . Args: data_source : See module overview. opts : Keyword list of options Options: See settings for the delegated module (e.g. Resourceful.Collection.Ecto ).","ref":"Resourceful.Collection.html#total/2","title":"Resourceful.Collection.total/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.html#t:name/0","title":"Resourceful.Collection.name/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.html#t:page_info/0","title":"Resourceful.Collection.page_info/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.html#t:queryable/0","title":"Resourceful.Collection.queryable/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.html#t:with_page_info/0","title":"Resourceful.Collection.with_page_info/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.html#t:with_page_info/1","title":"Resourceful.Collection.with_page_info/1","type":"type"},{"doc":"","ref":"Resourceful.Collection.Delegate.html","title":"Resourceful.Collection.Delegate","type":"protocol"},{"doc":"","ref":"Resourceful.Collection.Delegate.html#cast_filter/2","title":"Resourceful.Collection.Delegate.cast_filter/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Delegate.html#cast_sorter/2","title":"Resourceful.Collection.Delegate.cast_sorter/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Delegate.html#collection/1","title":"Resourceful.Collection.Delegate.collection/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.Delegate.html#filters/1","title":"Resourceful.Collection.Delegate.filters/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.Delegate.html#paginate/3","title":"Resourceful.Collection.Delegate.paginate/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Delegate.html#sort/2","title":"Resourceful.Collection.Delegate.sort/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Delegate.html#t:t/0","title":"Resourceful.Collection.Delegate.t/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.Ecto.html","title":"Resourceful.Collection.Ecto","type":"module"},{"doc":"","ref":"Resourceful.Collection.Ecto.html#all/2","title":"Resourceful.Collection.Ecto.all/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.html#any?/2","title":"Resourceful.Collection.Ecto.any?/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.html#repo/1","title":"Resourceful.Collection.Ecto.repo/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.html#total/2","title":"Resourceful.Collection.Ecto.total/2","type":"function"},{"doc":"Functions for converting Resourceful-style filters into Ecto-style SQL filters. See Resourceful.Collection.Filter for more details on filters. There's a lot of duplication here that can, hopefully, be resolved with a better understanding of macros.","ref":"Resourceful.Collection.Ecto.Filters.html","title":"Resourceful.Collection.Ecto.Filters","type":"module"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#equal/3","title":"Resourceful.Collection.Ecto.Filters.equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#exclude/3","title":"Resourceful.Collection.Ecto.Filters.exclude/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#greater_than/3","title":"Resourceful.Collection.Ecto.Filters.greater_than/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#greater_than_or_equal/3","title":"Resourceful.Collection.Ecto.Filters.greater_than_or_equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#include/3","title":"Resourceful.Collection.Ecto.Filters.include/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#less_than/3","title":"Resourceful.Collection.Ecto.Filters.less_than/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#less_than_or_equal/3","title":"Resourceful.Collection.Ecto.Filters.less_than_or_equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#not_equal/3","title":"Resourceful.Collection.Ecto.Filters.not_equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#starts_with/3","title":"Resourceful.Collection.Ecto.Filters.starts_with/3","type":"function"},{"doc":"Provides a common interface for filtering collections. See call/2 for use and examples. This module is intended to dispatch arguments to the appropriate Filter module for the underlying data source. Filtering is not meant to replace and be anything even resembling feature complete with more robust querying options provided by various databases. As The focus is on edge-facing APIs, generally web-based APIs, filthering is meant to be much simpler and more predictable. For instance, wildcard and regular expression filtering are omitted specifically by default. This is intentional.","ref":"Resourceful.Collection.Filter.html","title":"Resourceful.Collection.Filter","type":"module"},{"doc":"Returns a data source that is filtered in accordance with filters . If data_source is not an actual list of resources (e.g. an Ecto Queryable) underlying modules should not return a list of resources, but rather a filtered version of data_source . Args data_source : See Resourceful.Collection module overview. filters : A list of filters. See cast/1 for a list of valid filters.","ref":"Resourceful.Collection.Filter.html#call/2","title":"Resourceful.Collection.Filter.call/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Filter.html#cast!/1","title":"Resourceful.Collection.Filter.cast!/1","type":"function"},{"doc":"Converts an argument into an appropriate filter parameter. A castd filter is a tuple of containing an atom for the field name, an atom of the function name that will be called by the deligated module, and the value that will be used for comparison. Filter parameters can be provded as a tuple, list, or string and will be castd to the appropriate format. Invalid operators and their respective values will result in an exception. Please see valid_operator?/2 if you want to ensure client provided data is valid first. (Note: Should this throw an exception or should it return an :error tuple by default?) Examples cast({:age, &quot;gte&quot;, 18}) cast([&quot;age&quot;, &quot;gte&quot;, 18]) cast([&quot;age gte&quot;, 18])","ref":"Resourceful.Collection.Filter.html#cast/1","title":"Resourceful.Collection.Filter.cast/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.Filter.html#cast_as_list?/1","title":"Resourceful.Collection.Filter.cast_as_list?/1","type":"function"},{"doc":"Checks whether or not an operator is valid. Args op : Intended operator. Valid operators are keys in @shorthand .","ref":"Resourceful.Collection.Filter.html#valid_operator?/1","title":"Resourceful.Collection.Filter.valid_operator?/1","type":"function"},{"doc":"Checks whether or not an operator is valid in conjunction with an intended value. This can be used to validate the data from a client query. Args op : See valid_operator?/1 . val : The value to be used with the operator. Certain operators only work on a subset of value types. For instance sw is only valid with strings.","ref":"Resourceful.Collection.Filter.html#valid_operator?/2","title":"Resourceful.Collection.Filter.valid_operator?/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Filter.html#t:coercible/0","title":"Resourceful.Collection.Filter.coercible/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.Filter.html#t:t/0","title":"Resourceful.Collection.Filter.t/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.List.html","title":"Resourceful.Collection.List","type":"module"},{"doc":"","ref":"Resourceful.Collection.List.html#all/2","title":"Resourceful.Collection.List.all/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.html#any?/2","title":"Resourceful.Collection.List.any?/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.html#total/2","title":"Resourceful.Collection.List.total/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html","title":"Resourceful.Collection.List.Filters","type":"module"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#equal/3","title":"Resourceful.Collection.List.Filters.equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#exclude/3","title":"Resourceful.Collection.List.Filters.exclude/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#greater_than/3","title":"Resourceful.Collection.List.Filters.greater_than/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#greater_than_or_equal/3","title":"Resourceful.Collection.List.Filters.greater_than_or_equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#include/3","title":"Resourceful.Collection.List.Filters.include/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#less_than/3","title":"Resourceful.Collection.List.Filters.less_than/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#less_than_or_equal/3","title":"Resourceful.Collection.List.Filters.less_than_or_equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#not_equal/3","title":"Resourceful.Collection.List.Filters.not_equal/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Filters.html#starts_with/3","title":"Resourceful.Collection.List.Filters.starts_with/3","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html","title":"Resourceful.Collection.List.Sort","type":"module"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html#asc/2","title":"Resourceful.Collection.List.Sort.asc/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html#call/2","title":"Resourceful.Collection.List.Sort.call/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html#desc/2","title":"Resourceful.Collection.List.Sort.desc/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html#eq/2","title":"Resourceful.Collection.List.Sort.eq/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html#get_val/2","title":"Resourceful.Collection.List.Sort.get_val/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html#to_sorter/1","title":"Resourceful.Collection.List.Sort.to_sorter/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.List.Sort.html#to_sorters/2","title":"Resourceful.Collection.List.Sort.to_sorters/2","type":"function"},{"doc":"Provides a common interface for sorting collections. See call/2 for use and examples. This module is intended to dispatch arguments to the appropriate Sort module for the underlying data source.","ref":"Resourceful.Collection.Sort.html","title":"Resourceful.Collection.Sort","type":"module"},{"doc":"","ref":"Resourceful.Collection.Sort.html#all/1","title":"Resourceful.Collection.Sort.all/1","type":"function"},{"doc":"Returns a data source that is sorted in accordance with sorters . If data_source is not an actual list of resources (e.g. an Ecto Queryable) underlying modules should not return a list of resources, but rather a sorted version of data_source . Args data_source : See Resourceful.Collection module overview. sorters : A list or comma separated string of sort parameters. Sort parameters should be the string name of a field preceded by, optionally, a + for ascending order (the default) or a - for descending order or. Examples of sorters : &quot;name,-age&quot; [&quot;+name&quot;, &quot;-age&quot;]","ref":"Resourceful.Collection.Sort.html#call/2","title":"Resourceful.Collection.Sort.call/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Sort.html#cast!/1","title":"Resourceful.Collection.Sort.cast!/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.Sort.html#cast/1","title":"Resourceful.Collection.Sort.cast/1","type":"function"},{"doc":"","ref":"Resourceful.Collection.Sort.html#t:coercible/0","title":"Resourceful.Collection.Sort.coercible/0","type":"type"},{"doc":"","ref":"Resourceful.Collection.Sort.html#t:t/0","title":"Resourceful.Collection.Sort.t/0","type":"type"},{"doc":"Errors in Resourceful follow a few conventions. This module contains functions to help work with those conventions. Client-facing errors are loosely inspired by and should be easily converted to JSON:API-style errors , however they should also be suitable when JSON:API isn't used at all. Error Structure All errors returned in Resourceful are expected to be two element tuples where the first element is :error . This is a common Elixir and Erlang convention, but it's strict for the purposes of this library. Resourceful generates and expects one of two kinds of errors: Basic Errors Basic errors are always a two element tuple where the second element is an atom that should related to specific kind of error returned. These are meant for situations where context is either easily inferred, unnecessary, or obvious in some other manner. Example: {:error, :basic_err} Basic errors that require context are often transformed into contextual errors by higher level functions as they have context that lower level functions do not. Contextual Errors Contextual errors are always a two element tuple where the second element is another two element tuple in which the first element is an atom and the second element is a map containing contextual information such as user input, data being validated, and/or the source of the error. The map's keys must be atoms. Example: {:error, {:context_err, %{input: &quot;XYZ&quot;, source: [&quot;email_address&quot;]}} Errors outside of this format are not expected to work with these functions. Sources While not strictly required by contextual errors the :source key is used to indicate an element in a complex data structure that is responsible for a particular error. It must be a list of atoms, strings, or integers used to navigate a tree of data. Non-nested values should still be in the form of a list as prefixing sources is common. It's common for functions generating errors to be ignorant of their full context and higher level functions to prepend errors with their current location. Other Common Conventions There are a few other keys that appear in errors regularly: :detail : A human friendly description about the error. If there is information related to resolving the error, it belongs here. :input : A text representation of the actual input given by the client. It should be as close as possible to the original. (In general, IO.inspect/1 is used.) :key : Not to be confused with :source , a :key key should always be present when a lookup of data is done by some sort of key and there is a failure. :value : Not to be confused with :input , a :value key Note: all of these keys have convenience functions as it is a very common convention to create a new error with one of these keys or add one to an existing error. Error Types Both basic and contextual errors will contain an atom describing the specific type of error. These should be thought of as error codes and should be unique to the kinds of errors. For example, :attribute_not_found means that in some context, an attribute for a given resource doesn't exist. This could be an attempt to filter or sort. Either way, the error type remains the same. In both contexts, this error means the same thing. Contextual errors of a particular type should always contain at least some expected keys in their context maps. For example, :attribute_not_found should always contain a :name and may contain other information. More is usually better when it comes to errors. Keys should remain consistent in their use. :invalid_filter_operator , for example, should always contain an :attribute key implying that the failure was on a valid attribute whereas :attribute_not_found contains a :key key implying it was never resolved to an actual attribute.","ref":"Resourceful.Error.html","title":"Resourceful.Error","type":"module"},{"doc":"Mostly a convenience function to use instead of list/1 with the option to auto source errors as well. Additionally it will take a non-collection value and convert it to a list. Returns a list of errors.","ref":"Resourceful.Error.html#all/2","title":"Resourceful.Error.all/2","type":"function"},{"doc":"Recursively checks arbitrary data structures for any basic or contextual errors.","ref":"Resourceful.Error.html#any?/1","title":"Resourceful.Error.any?/1","type":"function"},{"doc":"Transverses an arbitrary data structure that may contain errors and prepends :source data given the error's position in the data structure using either an index from a list or a key from a map. Note: This will not work for keyword lists. In order to infer source information they must first be converted to maps. Returns input data structure with errors modified to contain :source in their context.","ref":"Resourceful.Error.html#auto_source/2","title":"Resourceful.Error.auto_source/2","type":"function"},{"doc":"Extracts the context map from an error. Returns a context map.","ref":"Resourceful.Error.html#context/1","title":"Resourceful.Error.context/1","type":"function"},{"doc":"Deletes key from an error's context map if present. Returns an error tuple.","ref":"Resourceful.Error.html#delete_context_key/2","title":"Resourceful.Error.delete_context_key/2","type":"function"},{"doc":"Converts errors from an Ecto Changeset into Resourceful errors. The type is inferred from the :validation key as Resourceful tends to use longer names. Rather than relying on separate input params, the :input is inserted from data , and :source is also inferred.","ref":"Resourceful.Error.html#from_changeset/1","title":"Resourceful.Error.from_changeset/1","type":"function"},{"doc":"Many error types should, at a minimum, have an associated :title . If there are regular context values, it should also include a :detail value as well. Both of these keys provide extra information about the nature of the error and can help the client understand the particulars of the provided context. While it might not be readily obvious what :key means in an error, if it is used in :detail it will help the client understand the significance. Unlike the error's type itself--which realistically should serve as an error code of sorts--the title should should be more human readable and able to be localized, although it should be consistent. Similarly, detail should be able to be localized although it can change depending on the specifics of the error or values in the context map. This function handles injecting default :title and :detail items into the context map if they are available for an error type and replacing context- related bindings in messages. (See message_with_context/2 for details.) In the future, this is also where localization should happen.","ref":"Resourceful.Error.html#humanize/2","title":"Resourceful.Error.humanize/2","type":"function"},{"doc":"Transforms an arbitrary data structure that may contain errors into a single, flat list of those errors. Non-error values are removed. Collections are checked recursively. Maps are given special treatment in that their values are checked but their keys are discarded. This format is meant to keep reading errors fairly simple and consistent at the edge. Clients can rely on reading a single list of errors regardless of whether transversing nested validation failures or handling more simple single fault situations. This function is also designed with another convention in mind: mixing successes and failures in a single payload. A design goal of error use in this library is to wait until as late as possible to return errors. That way, a single request can return the totality of its failure to the client. This way, many different paths can be evaluated and if there are any errors along the way, those errors can be returned in full.","ref":"Resourceful.Error.html#list/1","title":"Resourceful.Error.list/1","type":"function"},{"doc":"Replaces context bindings in a message with atom keys in a context map. A message of &quot;Invalid input %{input}.&quot; would have %{input} replaced with the value in the context map of :input`.","ref":"Resourceful.Error.html#message_with_context/2","title":"Resourceful.Error.message_with_context/2","type":"function"},{"doc":"Recursively transforms arbitrary data structures containing :ok tuples with just values. Values which are not in :ok tuples are left untouched. It does not check for errors. If errors are included, they will remain in the structure untouched. This function is designed to work on error free data and is unlikely to be used on its own but rather with or_ok/1 . Keyword lists where :ok may be included with other keys won't be returned as probably intended. Keep this limitation in mind. Returns the input data structure with all instances of {:ok, value} replaced with value .","ref":"Resourceful.Error.html#ok_value/1","title":"Resourceful.Error.ok_value/1","type":"function"},{"doc":"Checks an arbitrary data structure for errors and returns either the errors or valid data. See all/1 , any?/1 , and ok_value/1 for specific details as this function combines the three into a common pattern. Return the errors if there are any or the validated data. Returns either a list of errors wrapped in an :error tuple or valid data wrapped in an :ok tuple.","ref":"Resourceful.Error.html#or_ok/2","title":"Resourceful.Error.or_ok/2","type":"function"},{"doc":"Adds or prepends source context to an error. A common pattern when dealing with sources in nested data structures being transversed recursively is for the child structure to have no knowledge of the parent structure. Once the child errors are resolved the parent can then prepend its location in the structure to the child's errors.","ref":"Resourceful.Error.html#prepend_source/2","title":"Resourceful.Error.prepend_source/2","type":"function"},{"doc":"Adds a context map to an error if it lacks one, converting a basic error to a contextual error. It may also take a single atom to prevent error generating code from having to constantly wrap errors in an :error tuple.","ref":"Resourceful.Error.html#with_context/1","title":"Resourceful.Error.with_context/1","type":"function"},{"doc":"Adds the specified context as an error's context. If the error already has a context map the new context is merged.","ref":"Resourceful.Error.html#with_context/2","title":"Resourceful.Error.with_context/2","type":"function"},{"doc":"Adds a context map to an error if it lacks on and then puts the key and value into that map.","ref":"Resourceful.Error.html#with_context/3","title":"Resourceful.Error.with_context/3","type":"function"},{"doc":"Convenience function to create or modify an existing error with :input context.","ref":"Resourceful.Error.html#with_input/2","title":"Resourceful.Error.with_input/2","type":"function"},{"doc":"Convenience function to create or modify an existing error with :key context.","ref":"Resourceful.Error.html#with_key/2","title":"Resourceful.Error.with_key/2","type":"function"},{"doc":"Adds source context to an error and replaces :source if present.","ref":"Resourceful.Error.html#with_source/3","title":"Resourceful.Error.with_source/3","type":"function"},{"doc":"","ref":"Resourceful.Error.html#t:basic/0","title":"Resourceful.Error.basic/0","type":"type"},{"doc":"","ref":"Resourceful.Error.html#t:contextual/0","title":"Resourceful.Error.contextual/0","type":"type"},{"doc":"","ref":"Resourceful.Error.html#t:or_type/0","title":"Resourceful.Error.or_type/0","type":"type"},{"doc":"","ref":"Resourceful.Error.html#t:t/0","title":"Resourceful.Error.t/0","type":"type"},{"doc":"Tools for converting errors formatted in accordance with Resourceful.Error into JSON:API-style errors . JSON:API errors have a number of reserved top-level names: code detail id links meta source status title Resourceful errors map to JSON:API errors as follows: An error's type symbol is converted to a string for code . With the exception of meta and status the remainder of keys in an error's context are mapped to either the top-level attribute of the same name or, in the event the name is not a reserved name, it will be placed in meta which, if present, will always be a map. status is a bit of a special case as &quot;status&quot; in a JSON:API error always refers to an HTTP status code, but it's quite possible many errors might have a status attribute in their context that has nothing to do with HTTP. As such, :http_status may be passed either as an option or as a key in a context map.","ref":"Resourceful.JSONAPI.Error.html","title":"Resourceful.JSONAPI.Error","type":"module"},{"doc":"Takes a list of errors, or an :error tuple with a list as the second element, and converts that list to JSON:API errors.","ref":"Resourceful.JSONAPI.Error.html#all/2","title":"Resourceful.JSONAPI.Error.all/2","type":"function"},{"doc":"Returns a map of all non-reserved attributes from a context map.","ref":"Resourceful.JSONAPI.Error.html#meta/2","title":"Resourceful.JSONAPI.Error.meta/2","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Error.html#parameter_source/1","title":"Resourceful.JSONAPI.Error.parameter_source/1","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Error.html#pointer_source/1","title":"Resourceful.JSONAPI.Error.pointer_source/1","type":"function"},{"doc":"Returns a JSON:API source map based on the :source attribute in a an error's context map.","ref":"Resourceful.JSONAPI.Error.html#source/2","title":"Resourceful.JSONAPI.Error.source/2","type":"function"},{"doc":"Returns a JSON:API source map. Either: %{&quot;pointer&quot; =&gt; &quot;/data/attributes/problem&quot;} %{&quot;parameter&quot; =&gt; &quot;fields[resource_type]&quot;}","ref":"Resourceful.JSONAPI.Error.html#source_string/2","title":"Resourceful.JSONAPI.Error.source_string/2","type":"function"},{"doc":"Returns the appropriate status attribute based on either the context map or an explicitly passed :http_status option. The value in a context takes precedence. The reason for this is that the keyword will often be used in conjunction with all/2 to apply a default but certain errors, when a situation allows for mixed errors with statuses, will want to be set explicitly apart from the default.","ref":"Resourceful.JSONAPI.Error.html#status/2","title":"Resourceful.JSONAPI.Error.status/2","type":"function"},{"doc":"Converts a Resourceful error into a JSON:API error map which can then be converted to JSON. See module overview for details on conventions.","ref":"Resourceful.JSONAPI.Error.html#to_map/2","title":"Resourceful.JSONAPI.Error.to_map/2","type":"function"},{"doc":"Functions for validating fields, primarily for use with JSON:API sparse fieldsets . Fields are provided by type type_name in requests and not inferred from root or relationship names. This means that if a type has multiple relationships pointing to a single type or a self-referential relationships, these will be applied to all instances of that type type_name regardless of its location in the graph. Since this is specific to JSON:API, field names are not converted to atoms in the generation options after successful validation. There's no need since these prevent any mapping from occurring and never make it to the data layer. It's also important to note that a &quot;field&quot; is specifically defined and is a collection of attribute names and relationship names. It specifically excludes id and type despite all identifiers sharing a common namespace. NOTE: Relationships are currently not supported.","ref":"Resourceful.JSONAPI.Fields.html","title":"Resourceful.JSONAPI.Fields","type":"module"},{"doc":"Takes a map of fields by type type_name (e.g. %{&quot;albums&quot; =&gt; [&quot;releaseDate&quot;, &quot;title&quot;]} ) and validates said fields against the provided type. If fields are included that are not part of a particular type, errors will be returned.","ref":"Resourceful.JSONAPI.Fields.html#validate/2","title":"Resourceful.JSONAPI.Fields.validate/2","type":"function"},{"doc":"Functions for validating includes, primarily for use with JSON:API inclusion of related resources . Includes are just relationships names on the root type. A song, for instance, could include the album and, depending on the depth settings, could even include the album's artist.","ref":"Resourceful.JSONAPI.Include.html","title":"Resourceful.JSONAPI.Include","type":"module"},{"doc":"Validates whether a relationship may be included. A graphed relationship where graph? is true may be included.","ref":"Resourceful.JSONAPI.Include.html#validate/2","title":"Resourceful.JSONAPI.Include.validate/2","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Include.html#validate/3","title":"Resourceful.JSONAPI.Include.validate/3","type":"function"},{"doc":"Validates parameters provided by various pagination strategies and returns paramaters as expected by Resourceful.Collection .","ref":"Resourceful.JSONAPI.Pagination.html","title":"Resourceful.JSONAPI.Pagination","type":"module"},{"doc":"","ref":"Resourceful.JSONAPI.Pagination.html#validate/2","title":"Resourceful.JSONAPI.Pagination.validate/2","type":"function"},{"doc":"Functions for converting URL parameters into Resourceful queries. Additionally validates parameters when JSON:API-specific parameters are provided such as fields . While JSON:API specifically designates the format for sparse fieldsets and sorting, filtering and pagination is left up to the implementation. Filtering is build around the generic queries in Resourceful and is therefore opinionated in format. Pagination supports a page number and limit/offset strategies. There is currently no support for include . Comma-Separated Lists and Arrays The JSONAPI spec shows examples of sparse fieldsets and sorting using comma-separated strings to represent arrays of fields. In addition to the standard form, this library will also accept an actual array of strings. The errors that are returned will differ depending on the form--specifically, the :input and :source values. This is intentional behavior. For example, sort=-field1,field2 and sort[]=-field1&amp;sort[]=field2 will return identitcal results if the fields are correct for the type, however if field1 is invalid the errors will look slightly different: String list: {:invalid_jsonapi_field, %{input: &quot;field1,field2&quot;, key: &quot;field1&quot;, source: [&quot;sort&quot;]}} Array: {:invalid_jsonapi_field, %{input: &quot;field1&quot;, key: &quot;field1&quot;, source: [&quot;sort&quot;, 0]}}","ref":"Resourceful.JSONAPI.Params.html","title":"Resourceful.JSONAPI.Params","type":"module"},{"doc":"","ref":"Resourceful.JSONAPI.Params.html#split_string_list/1","title":"Resourceful.JSONAPI.Params.split_string_list/1","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Params.html#validate/3","title":"Resourceful.JSONAPI.Params.validate/3","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_fields/2","title":"Resourceful.JSONAPI.Params.validate_fields/2","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_filter/2","title":"Resourceful.JSONAPI.Params.validate_filter/2","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_include/2","title":"Resourceful.JSONAPI.Params.validate_include/2","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_page/2","title":"Resourceful.JSONAPI.Params.validate_page/2","type":"function"},{"doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_sort/3","title":"Resourceful.JSONAPI.Params.validate_sort/3","type":"function"},{"doc":"","ref":"Resourceful.Registry.html","title":"Resourceful.Registry","type":"module"},{"doc":"Instances of Resourceful.Type are intended to be used in conjunction with a registry in most circumstances. The application, and even the client, will likely understand a resource type by its string name/identifier. Types themselves, when associated with a registry, will be able to reference each other as well, which forms the basis for relationships. A module using the Registry behaviour becomes a key/value store. defresourcefultype/1 allows the types to be evaluated entirely at compile time.","ref":"Resourceful.Registry.html#__using__/1","title":"Resourceful.Registry.__using__/1","type":"macro"},{"doc":"Builds a field graph for a Resourceful.Type . Since types have a max_depth , all possible graphed fields can be computed and cached at compile time when using a registry. This allows nested fields to be treated like local fields in the sense that they are available in a flat map. For example, a song type would have a title field. Once graphed, it would also have an album.title field. If the depth was set to 2, access to a field like album.artist.name would also be available. This prevents a lot of recursion logic from being applied at every lookup and by instecting the field graph for a type it's easy to see all of the possible mappings. Graphed fields are wrapped in a Resourceful.Type.GraphedField struct which contains relational information about the field in addition to the field data itself. See Resourceful.Type.max_depth/2 for information about what is intended to be included in a field graph based on the depth setting.","ref":"Resourceful.Registry.html#build_field_graph/2","title":"Resourceful.Registry.build_field_graph/2","type":"function"},{"doc":"","ref":"Resourceful.Registry.html#do_build_field_graph/7","title":"Resourceful.Registry.do_build_field_graph/7","type":"function"},{"doc":"","ref":"Resourceful.Registry.html#fetch!/2","title":"Resourceful.Registry.fetch!/2","type":"function"},{"doc":"","ref":"Resourceful.Registry.html#fetch/2","title":"Resourceful.Registry.fetch/2","type":"function"},{"doc":"","ref":"Resourceful.Registry.html#fetch_field_graph!/2","title":"Resourceful.Registry.fetch_field_graph!/2","type":"function"},{"doc":"","ref":"Resourceful.Registry.html#fetch_field_graph/2","title":"Resourceful.Registry.fetch_field_graph/2","type":"function"},{"doc":"A name can be optionally passed to the type/2 macro. If provided, this name will override the name of the resource created in provided block.","ref":"Resourceful.Registry.html#maybe_put_name/2","title":"Resourceful.Registry.maybe_put_name/2","type":"function"},{"doc":"Assigns the resource specified in the block and makes it part of the registry. If name is provided, it will rename the resource and use that name as the key. If block does not result in a Resourceful.Type an exception will be raised.","ref":"Resourceful.Registry.html#type/2","title":"Resourceful.Registry.type/2","type":"macro"},{"doc":"Ensures a value is a Resourceful.Type and that no type of the same name exists in the map. Raises an exception if both conditions are not met.","ref":"Resourceful.Registry.html#validate_type!/2","title":"Resourceful.Registry.validate_type!/2","type":"function"},{"doc":"Resourceful.Type is a struct and set of functions for representing and mapping internal data structures to data structures more appropriate for edge clients (e.g. API clients). As a result, field names are always strings and not atoms. In addition to mapping data field names, it validates that client representations conform to various constraints set by the type. These include transversing field graphs, limiting which fields can be queried, and how deep down the graph queries can go. The naming conventions and some of design philosophy is geared heavily toward APIs over HTTP and JSON:API specification . However, there is nothing JSON-API specific about types. Fields A &quot;field&quot; refers to an attribute or a relationship on a given type. These share a common namespace and in some respects can be treated interchangeably. There is a distinction between &quot;local&quot; fields and &quot;query&quot; fields. Local fields are those which are directly on the current type. For example, a type of album may have local attributes such as a title and release date and local relationships such as artist and songs. Query fields are a combination of local fields and fields anywhere in the resource graph. So, in the above example, query fields would include something like an album's title and the related artist's name. ### Relationships and Registries In order to use relationships, a type must be included in a Resourceful.Registry and, in general, types are meant to be used in conjunction with a registry. In most functions dealing with relationships and related types, a type's name (just a string) is used rather than passing a type struct. The struct itself will be looked up from the registry. Queries The term &quot;query&quot; is used to refer to filtering and sorting collections of resources. Since queries ultimately work on attributes, fields eligible to be queried must be attributes. You could sort songs by an album's title but you wouldn't reasonably sort them by an album resource. Fields given for a query can be represented as a list of strings or as a dot separated string. So, when looking at a song, the artist's name could be accessed through &quot;album.artist.name&quot; or [&quot;album&quot;, &quot;artist&quot;, &quot;name&quot;] . As with many things related to types, string input from API sources is going to be the most common form of input. &quot;Root&quot; Types Resource graphs are put together from the perspective of a &quot;root&quot; type. Any type can be a root type. In the example of an API, if you were looking at an album, it would be the root with its songs and artist further down the graph. Building Types In addition to functions that actually do something with types, there are a number of functions used for transforming types such as max_depth/2 . As types are designed with registries in mind, types can be built at compile-time using transformation functions in a manner that may be easier to read than new/2 with options. Ecto Schemas There is some overlap with Ecto.Schema . In fact, attribute types use the same type system. While schemas can be used for edge data, primarily when coupled with change sets, types are more specifically tailored to the task. Types, combined with Resourceful.Collection can be combined to construct a queryable API with concerns that are specific to working with the edge. The query format is specifically limited for this purpose.","ref":"Resourceful.Type.html","title":"Resourceful.Type","type":"module"},{"doc":"Returns a list of the name of all attribute fields.","ref":"Resourceful.Type.html#attribute_names/1","title":"Resourceful.Type.attribute_names/1","type":"function"},{"doc":"Sets a key in the cache map. Because types generally intended to be static at compile time, it can make sense to cache certain values and have functions look for cached values in the cache map. For instance, finalize/1 creates a MapSet for related_types which related_types/1 will use instead of computed the MapSet . Caches are not meant to be memoized, rather set on a type once it is considered complete.","ref":"Resourceful.Type.html#cache/3","title":"Resourceful.Type.cache/3","type":"function"},{"doc":"Fetches a local attribute or, if a registry is set, a graphed attribute.","ref":"Resourceful.Type.html#fetch_attribute/2","title":"Resourceful.Type.fetch_attribute/2","type":"function"},{"doc":"Same as fetch_field/2 but raises FieldError if the field isn't present.","ref":"Resourceful.Type.html#fetch_field!/2","title":"Resourceful.Type.fetch_field!/2","type":"function"},{"doc":"Fetches a local field or, if a registry is set, a graphed field.","ref":"Resourceful.Type.html#fetch_field/3","title":"Resourceful.Type.fetch_field/3","type":"function"},{"doc":"Same as fetch_graphed_field/2 but raises FieldError if the graphed field isn't present. Unless you have a specific reason for fetching only graphed fields, use fetch_field!/3 instead.","ref":"Resourceful.Type.html#fetch_graphed_field!/2","title":"Resourceful.Type.fetch_graphed_field!/2","type":"function"},{"doc":"Fetches a field with related graph data using the resource's field graphs. Unless you have a specific reason for fetching only graphed fields, use fetch_field/3 instead.","ref":"Resourceful.Type.html#fetch_graphed_field/3","title":"Resourceful.Type.fetch_graphed_field/3","type":"function"},{"doc":"Same as fetch_local_field/2 but raises FieldError if the local field isn't present. Unless you have a specific reason for fetching local fields, use fetch_field/3 instead.","ref":"Resourceful.Type.html#fetch_local_field!/3","title":"Resourceful.Type.fetch_local_field!/3","type":"function"},{"doc":"Fetches a local field by name. Unless you have a specific reason for fetching local fields, use fetch_field/3 instead.","ref":"Resourceful.Type.html#fetch_local_field/3","title":"Resourceful.Type.fetch_local_field/3","type":"function"},{"doc":"Fetches another type by name from a type's registry.","ref":"Resourceful.Type.html#fetch_related_type/2","title":"Resourceful.Type.fetch_related_type/2","type":"function"},{"doc":"Fetches a local relationship or, if a registry is set, a graphed relationship.","ref":"Resourceful.Type.html#fetch_relationship/2","title":"Resourceful.Type.fetch_relationship/2","type":"function"},{"doc":"Fetches the field graph for a given type if the type exists and has a registry.","ref":"Resourceful.Type.html#field_graph/1","title":"Resourceful.Type.field_graph/1","type":"function"},{"doc":"","ref":"Resourceful.Type.html#finalize/1","title":"Resourceful.Type.finalize/1","type":"function"},{"doc":"Checks if a type has a local field.","ref":"Resourceful.Type.html#has_local_field?/2","title":"Resourceful.Type.has_local_field?/2","type":"function"},{"doc":"Sets the attribute to be used as the ID attribute for a given type. The ID field has slightly special usage in that extensions will use it for both identification and equality. There are also conveniences for working directly with IDs such as get_id/2 . A limitation of types is that currently composite ID fields are not supported.","ref":"Resourceful.Type.html#id/2","title":"Resourceful.Type.id/2","type":"function"},{"doc":"Validates and returns the mapped names from a graph","ref":"Resourceful.Type.html#map_field/2","title":"Resourceful.Type.map_field/2","type":"function"},{"doc":"Maps the ID value for a given resource. This is just shorthand for using map_value/3 on whatever field is designated as the ID.","ref":"Resourceful.Type.html#map_id/2","title":"Resourceful.Type.map_id/2","type":"function"},{"doc":"Maps a value for a given field name for a resource.","ref":"Resourceful.Type.html#map_value/3","title":"Resourceful.Type.map_value/3","type":"function"},{"doc":"Takes mappable resource, a type, and a list of fields. Returns a list of tuples with the field name and the mapped value. This is returned instead of a map to preserve the order of the input list. If order is irrelevant, use to_map/2 instead.","ref":"Resourceful.Type.html#map_values/3","title":"Resourceful.Type.map_values/3","type":"function"},{"doc":"Sets max_depth on a type. max_depth is specifically a reference to the depth of relationships that will be transversed. This means the default max_depth of 1 would expose all immediate relationships and their attributes. For example, a song type with a max_depth of 1 would be able to graph through album and query against album.title but would not be able to access album.artist or any of its attributes. Increasing the max_depth to 2 would expose album.artist.name .","ref":"Resourceful.Type.html#max_depth/2","title":"Resourceful.Type.max_depth/2","type":"function"},{"doc":"Sets max_filters on a type. This is the total number of filters allowed in a single query.","ref":"Resourceful.Type.html#max_filters/2","title":"Resourceful.Type.max_filters/2","type":"function"},{"doc":"Sets max_sorters on a type. This is the total number of sorts allowed in a single query.","ref":"Resourceful.Type.html#max_sorters/2","title":"Resourceful.Type.max_sorters/2","type":"function"},{"doc":"Adds a value to the meta map. Meta information is not used by types directly in this module. It is intended to add more information that can be used by extensions and other implementations. For example, JSON:API resources provide linkage and describing that linkage is an appropriate use of the meta map. Cached values should not be put in the meta map. Though both cache and meta could essentially be used for the same thing, caches are expected to be set specially when registering a type in Resourceful.Registry because without_cache/1 is called before finalizing a type.","ref":"Resourceful.Type.html#meta/3","title":"Resourceful.Type.meta/3","type":"function"},{"doc":"Sets name on a type. Name must be strings and cannot contain periods. Atoms will be automatically converted to strings.","ref":"Resourceful.Type.html#name/2","title":"Resourceful.Type.name/2","type":"function"},{"doc":"Creates a new Resourceful.Type with valid attributes. See functions of the same name for more information on key functionality. For fields, see Resourceful.Type.Attribute and Resourceful.Type.Relationship .","ref":"Resourceful.Type.html#new/2","title":"Resourceful.Type.new/2","type":"function"},{"doc":"Puts a new field in the fields map using the field's name as the key. This will replace a field of the same name if present.","ref":"Resourceful.Type.html#put_field/2","title":"Resourceful.Type.put_field/2","type":"function"},{"doc":"Sets the registry module for a type. In general, this functional will be called by a Resourceful.Registry and not directly.","ref":"Resourceful.Type.html#register/2","title":"Resourceful.Type.register/2","type":"function"},{"doc":"Returns a list of the name of all relationship fields.","ref":"Resourceful.Type.html#relationship_names/1","title":"Resourceful.Type.relationship_names/1","type":"function"},{"doc":"Returns a name as a dot-separated string.","ref":"Resourceful.Type.html#string_name/1","title":"Resourceful.Type.string_name/1","type":"function"},{"doc":"Like map_values/3 only returns a map with keys in the name of the attributes with with values of the mapped values.","ref":"Resourceful.Type.html#to_map/3","title":"Resourceful.Type.to_map/3","type":"function"},{"doc":"Validates a single filter on an attribute.","ref":"Resourceful.Type.html#validate_filter/2","title":"Resourceful.Type.validate_filter/2","type":"function"},{"doc":"Returns a valid mapping name for a field. Any atom or string is valid and should map to the whatever the underlying resources will look like.","ref":"Resourceful.Type.html#validate_map_to!/1","title":"Resourceful.Type.validate_map_to!/1","type":"function"},{"doc":"Validates that the max number of filters hasn't been exceeded.","ref":"Resourceful.Type.html#validate_max_filters/3","title":"Resourceful.Type.validate_max_filters/3","type":"function"},{"doc":"Validates that the max number of sorters hasn't been exceeded.","ref":"Resourceful.Type.html#validate_max_sorters/3","title":"Resourceful.Type.validate_max_sorters/3","type":"function"},{"doc":"Returns a valid string name for a type or field. Technically any string without a period is valid, but like most names, don't go nuts with URL characters, whitespace, etc.","ref":"Resourceful.Type.html#validate_name!/1","title":"Resourceful.Type.validate_name!/1","type":"function"},{"doc":"Validates a single sorter on an attribute.","ref":"Resourceful.Type.html#validate_sorter/2","title":"Resourceful.Type.validate_sorter/2","type":"function"},{"doc":"Returns an existing type with an empty cache key.","ref":"Resourceful.Type.html#without_cache/1","title":"Resourceful.Type.without_cache/1","type":"function"},{"doc":"A field is an attribute or a relationship. They share the same namespace within a type.","ref":"Resourceful.Type.html#t:field/0","title":"Resourceful.Type.field/0","type":"type"},{"doc":"","ref":"Resourceful.Type.html#t:field_graph/0","title":"Resourceful.Type.field_graph/0","type":"type"},{"doc":"","ref":"Resourceful.Type.html#t:field_name/0","title":"Resourceful.Type.field_name/0","type":"type"},{"doc":"","ref":"Resourceful.Type.html#t:queryable/0","title":"Resourceful.Type.queryable/0","type":"type"},{"doc":"","ref":"Resourceful.Type.html#t:t/0","title":"Resourceful.Type.t/0","type":"type"},{"doc":"Attributes represent &quot;value&quot; fields for a given Resourceful.Type . This governs a few common operations: Casting Inputs Values will often come in the form of strings from the edge. Attributes use Ecto's typecasting to cast inputs into proper datatype or return appropriate errors. Mapping to Underlying Resources Generally speaking, outside representation of resources will use strings as keys on maps whereas internal structures tend to be atoms. Additionally, internal structures will often use snake case whereas external structures may take multiple forms (e.g. camel case or dasherized when dealing with JSON:API). Attributes map values to their appropriate internal keys. Configuring Queries APIs may choose to restrict what attributes can be filtered and sorted. For instance, you make wish to only allow public queries against indexed attributes or none at all. This allows the system restrict access and return meaningful errors when a client attempts to query against an attribute.","ref":"Resourceful.Type.Attribute.html","title":"Resourceful.Type.Attribute","type":"module"},{"doc":"Casts an input into an attribute's type. If cast_as_list is true, it will wrap the attribute's type in a list. This is specifically for dealing with filters that take a list of values.","ref":"Resourceful.Type.Attribute.html#cast/3","title":"Resourceful.Type.Attribute.cast/3","type":"function"},{"doc":"Creates a contextual error wthe attribute's name in the context.","ref":"Resourceful.Type.Attribute.html#error/3","title":"Resourceful.Type.Attribute.error/3","type":"function"},{"doc":"Sets the filter? key for an attribute. Collections cannot be filtered by an attribute unless this is set to true .","ref":"Resourceful.Type.Attribute.html#filter/2","title":"Resourceful.Type.Attribute.filter/2","type":"function"},{"doc":"Sets the map_to key for an attribute. map_to is the key of the underlying map to use in place of the attribute's actual name . Unlike a name which can only be a string, this can be an atom or a string (dots allowed).","ref":"Resourceful.Type.Attribute.html#map_to/2","title":"Resourceful.Type.Attribute.map_to/2","type":"function"},{"doc":"Sets the name for the attribute. This is the &quot;edge&quot; name that clients will interact with. It can be any string as long as it doesn't contain dots. This will also serve as its key name if used in conjunction with a Resourceful.Type which is important in that names must be unique within a type.","ref":"Resourceful.Type.Attribute.html#name/2","title":"Resourceful.Type.Attribute.name/2","type":"function"},{"doc":"Creates a new attribute, coerces values, and sets defaults.","ref":"Resourceful.Type.Attribute.html#new/3","title":"Resourceful.Type.Attribute.new/3","type":"function"},{"doc":"A shortcut for setting both filter? and sort? to the same value.","ref":"Resourceful.Type.Attribute.html#query/2","title":"Resourceful.Type.Attribute.query/2","type":"function"},{"doc":"Sets the sort? key for an attribute. Collections cannot be sorted by an attribute unless this is set to true .","ref":"Resourceful.Type.Attribute.html#sort/2","title":"Resourceful.Type.Attribute.sort/2","type":"function"},{"doc":"Sets the data type for casting. This must be an Ecto.Type or atom that works in its place such as :string .","ref":"Resourceful.Type.Attribute.html#type/2","title":"Resourceful.Type.Attribute.type/2","type":"function"},{"doc":"Validates a filter against the attribute and the data given. It ensures the data type is correct for the operator and that the attribute allows filtering at all.","ref":"Resourceful.Type.Attribute.html#validate_filter/3","title":"Resourceful.Type.Attribute.validate_filter/3","type":"function"},{"doc":"Validates a sorter against the attribute ensuring that sorting is allowed for the attribute.","ref":"Resourceful.Type.Attribute.html#validate_sorter/2","title":"Resourceful.Type.Attribute.validate_sorter/2","type":"function"},{"doc":"Functions for import in Resourceful.Registry for building types programmatically.","ref":"Resourceful.Type.Builders.html","title":"Resourceful.Type.Builders","type":"module"},{"doc":"","ref":"Resourceful.Type.Builders.html#attribute/4","title":"Resourceful.Type.Builders.attribute/4","type":"function"},{"doc":"","ref":"Resourceful.Type.Builders.html#has_many/3","title":"Resourceful.Type.Builders.has_many/3","type":"function"},{"doc":"","ref":"Resourceful.Type.Builders.html#has_one/3","title":"Resourceful.Type.Builders.has_one/3","type":"function"},{"doc":"","ref":"Resourceful.Type.Builders.html#relationship/4","title":"Resourceful.Type.Builders.relationship/4","type":"function"},{"doc":"Creates a Resourceful.Type from an Ecto.Schema module. The use case is that internal data will be represented by the schema and client-facing data will be represented by the resource definition. Additionally, field names may be mapped differently to the client, such as camel case values. This can be done individually or with a single function as an option. Since Resourceful.Type instances use the same type system as Ecto, this is a relatively straightforward conversion.","ref":"Resourceful.Type.Ecto.html","title":"Resourceful.Type.Ecto","type":"module"},{"doc":"Returns a Resourceful.Type.Attribute based on a field from an Ecto.Schema module.","ref":"Resourceful.Type.Ecto.html#attribute/3","title":"Resourceful.Type.Ecto.attribute/3","type":"function"},{"doc":"Returns a Resourceful.Type from an Ecto.Schema module by inferring values from the schema. Options For most options, a list of schema field names (atoms) will be passed in specifying the type's configuration for those fields. In these cases a value of true or :all will result in all fields being used. For example if you wanted to be able to query all fields, you would pass [query: :all] . :except - Schema fields to be excluded from the type. :filter - Schema fields allowed to be filtered. :only - Schema fields to be included in the type. :query - Schema fields allowed to be queried (sorted and filtered). :sort - Schema fields allowed to be sorted. :transform_names - A single argument function that takes the field name (an atom) and transforms it into either another atom or a string. A type of case conversion is the most likely use case. Addionally, any options not mentioned above will be passed directly to Resourceful.Type.new/2 .","ref":"Resourceful.Type.Ecto.html#type_with_schema/2","title":"Resourceful.Type.Ecto.type_with_schema/2","type":"function"},{"doc":"This module is something of hack designed to deal with the fact that Ecto does not make it simple to: Dynamically assigned aliases to joins. When specifying :as it must be a compile-time atom. A recent reference to this issue can be found here . This was learned the hard way. This is especially frustrating because the aside from assignment, the aliases can be referenced dynamically throughout the rest of the query DSL with a ^ . Preload joins if a join is already present and handle join introspection in general. The easiest way to solve this was to manipulate the struct because there's nothing magical about aliases. They're just a named reference to a positional binding. Preloads operate similarly. A tree of tuples and keyword lists defines which associations should be preloaded. Join introspection is also important so fields can be added to a query in an ad-hoc manner without having to care whether the query contains joins or not. A Note About Intended Use Cases It's important to remember that unless you go out of your way to mess with data structures in fields (I say this because this module is going out of its way to mess with data structures) relationships that support inclusion must follow a one-to-one path from start to finish. See Resourceful.Type.Relationship for a broader explanation on this design decision. Is this a good idea? It's certainly possible the underlying Ecto.Query structs change. This sort of manipulation is effectively using a private API. Hopefully getting proper support for this behavior is doable. Additionally, it's possible to handle some (and maybe all) of this using macros. However, that ultimately seemed every more convoluted and confusing. At least this is mostly simple recursion. What it does do is solve the problem it needed to solve.","ref":"Resourceful.Type.Ecto.Query.html","title":"Resourceful.Type.Ecto.Query","type":"module"},{"doc":"Including a field does two things: It automatically joins any necessary relationships (see join_field/3 ). It preloads said relationships. This allows a single query to bring back all of the data and also allows filtering and sorting to work on related attributes, not just those of the root type. For reference, an Ecto.Query stores preload instructions meant to happen with joins in the :assocs key in the form of a tree of keyword lists and tuples. A single join looks like this: [&lt;assoc_name&gt;: {&lt;position&gt;, []}] The tuple contains the position of the binging for the related join and a list of any child joins which would be in the same form as the parent. In the song/album/artist example this could look like the following: [album: {1, [artist: {2, []}]}] .","ref":"Resourceful.Type.Ecto.Query.html#include_field/3","title":"Resourceful.Type.Ecto.Query.include_field/3","type":"function"},{"doc":"Joining a field joins all associations connected to all relationships in the field's graph. For example, if viewing a song and the field album.artist.name is joined, two relationships will be joined: the song's album , and the album's artist . The join will be given an alias of the full relationship name. So, the album will be aliases as album and the artist will be aliased as album.artist . If those joins have already been made, the queryable will remain unchanged. Fields resolving to attributes are ignored, but if they are children of a relationship, the relationship will be included.","ref":"Resourceful.Type.Ecto.Query.html#join_field/2","title":"Resourceful.Type.Ecto.Query.join_field/2","type":"function"},{"doc":"Like join_field/2 except it takes a type and a field name rather than the graphed field directly.","ref":"Resourceful.Type.Ecto.Query.html#join_field/3","title":"Resourceful.Type.Ecto.Query.join_field/3","type":"function"},{"doc":"A graphed field is a field (an attribute or a relationship) bundled with graph data dictating how it is to be mapped in a graph from the perspective of a type. For example, while the attribute title on an album will always be the same value. However, when that attribute is viewed from the perspective of a song or an artist graph information needs to be included. On it's own the attribute might map to :title but from a song it would map to [:album, :title] . The query_alias is used for Ecto to idenify a join with the :as option used.","ref":"Resourceful.Type.GraphedField.html","title":"Resourceful.Type.GraphedField","type":"module"},{"doc":"Creates a new graphed field. This function will almost never be called directly but rather as part of Resourceful.Registry.build_field_graph/2 .","ref":"Resourceful.Type.GraphedField.html#new/4","title":"Resourceful.Type.GraphedField.new/4","type":"function"},{"doc":"Relationships come in one of two types: :one or :many . Things like foreign keys and how the relationships map are up to the underlying data source. For the purposes of mapping things in Resourceful , it simply needs to understand whether it's working with a single thing or multiple things. A natural opinion of relationships is that graphing is simply not allowed on :many relationships. What this means is that you can only do graphed filters and sorts against :one relationships. For example, a song can sort and filter on an album and its artist because a song has one album which has one artist. The reverse is not possible because an artist has many albums which have many songs. Sorting and filtering on relationships makes sense when data can be represented as a table. In situations where it's a tree, multiple queries are necessary and the client is responsible for putting the data together. It makes sense to filter and sort a song by an album or artist's attribute. It does not make sense to sort an artist by a song's attribute.","ref":"Resourceful.Type.Relationship.html","title":"Resourceful.Type.Relationship","type":"module"},{"doc":"Sets the name for the relationship. This is the &quot;edge&quot; name that clients will interact with. It can be any string as long as it doesn't contain dots. This will also serve as its key name if used in conjunction with a Resourceful.Type which is important in that names must be unique within a type.","ref":"Resourceful.Type.Relationship.html#name/2","title":"Resourceful.Type.Relationship.name/2","type":"function"},{"doc":"Creates a new relationship, coerces values, and sets defaults.","ref":"Resourceful.Type.Relationship.html#new/3","title":"Resourceful.Type.Relationship.new/3","type":"function"},{"doc":"","ref":"Resourceful.Type.Relationship.html#t:type/0","title":"Resourceful.Type.Relationship.type/0","type":"type"},{"doc":"Extra utility functions. These are for miscellaneous shared functions that don't really fit with any other module but are shared across multiple modules.","ref":"Resourceful.Util.html","title":"Resourceful.Util","type":"module"},{"doc":"Allows :except or :only options to be set in a keyword set of options. The options and the set are given as arguments and, depending on the options, a subset (or the set itself) will be returned. An exception will be raised if invalid arguments are passed or if both :except and :only are passed.","ref":"Resourceful.Util.html#except_or_only!/2","title":"Resourceful.Util.except_or_only!/2","type":"function"},{"doc":"","ref":"Resourceful.Collection.Ecto.NoRepoError.html","title":"Resourceful.Collection.Ecto.NoRepoError","type":"exception"},{"doc":"","ref":"Resourceful.Registry.DuplicateTypeNameError.html","title":"Resourceful.Registry.DuplicateTypeNameError","type":"exception"},{"doc":"","ref":"Resourceful.Registry.InvalidType.html","title":"Resourceful.Registry.InvalidType","type":"exception"},{"doc":"","ref":"Resourceful.Registry.NotRegisteredError.html","title":"Resourceful.Registry.NotRegisteredError","type":"exception"},{"doc":"","ref":"Resourceful.Type.FieldError.html","title":"Resourceful.Type.FieldError","type":"exception"},{"doc":"","ref":"Resourceful.Type.InvalidMapTo.html","title":"Resourceful.Type.InvalidMapTo","type":"exception"},{"doc":"","ref":"Resourceful.Type.InvalidName.html","title":"Resourceful.Type.InvalidName","type":"exception"}]